Problem 297: Zeckendorf Representation

(see projecteuler.net/problem=297)

Each new term in the Fibonacci sequence is generated by adding the previous two terms.
Starting with 1 and 2, the first 10 terms will be: 1, 2, 3, 5, 8, 13, 21, 34, 55, 89.

Every positive integer can be uniquely written as a sum of nonconsecutive terms of the Fibonacci sequence.
For example, 100 = 3 + 8 + 89.
Such a sum is called the Zeckendorf representation of the number.

For any integer n>0, let z(n) be the number of terms in the Zeckendorf representation of n.
Thus, z(5) = 1, z(14) = 2, z(100) = 3 etc.
Also, for 0 < n < 10^6, sum{z(n)} = 7894453.

Find sum{z(n)} for 0 < n < 10^17.

My Algorithm

Often I write a simple brute-force program which produces the correct result for small inputs.
The function zeckendorf returns the number of terms in the Zeckendorf representation of a single number.
According to the Wikipedia page on the Zeckendorf theorem (en.wikipedia.org/wiki/Zeckendorf's_theorem) a greedy repeated search
for the largest Fibonacci numbers <= the current number is sufficient.

Then I printed the first 100 numbers (and their sum) and discovered the pattern:
the number of terms repeats after each new Fibonacci number, abeit increased by one. For example:

numberzeckendorf(number)sumfiboSum
1111
2122
3133
425 
5166
628 
7210 
811111
9213 
10215 
11217 
12320 
1312121
14223 
15225 
16227 
17330 
18232 
19335 
20338 
2113939

The Zeckendorf representation is always 1 for a Fibonacci number (which are bold in the table above).
My array fiboSum contains the running total (the sum) for each n-th Fibonacci number:
fiboSum[n] = fiboSum[n - 1] + fiboSum[n - 2] + fibonacci[n - 2] - 1

Using that relationship my function search recursively subtracts the largest possible Fibonacci number
while adding the relevant value fiboSum.

Note

The zeckendorf function isn't needed anymore but I didn't remove it because my gut tells me I could use it in the future ...

Interactive test

You can submit your own input to my program and it will be instantly processed at my server:

Input data (separated by spaces or newlines):

This is equivalent to
echo 1000000 | ./297

Output:

(please click 'Go !')

Note: the original problem's input 100000000000000000 cannot be entered
because just copying results is a soft skill reserved for idiots.

(this interactive test is still under development, computations will be aborted after one second)

My code

… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.

#include <iostream>
#include <vector>
 
// all Fibonacci numbers below 10^17
std::vector<unsigned long long> fibonacci;
// and the sum according to my algorithm description
std::vector<unsigned long long> fiboSum; // fibonacci.size() == fiboSum.size()
 
// see en.wikipedia.org/wiki/Zeckendorf's_theorem
// return the length of the Zeckendorf representation of x
unsigned int zeckendorf(unsigned long long x)
{
unsigned int result = 0;
 
// greedy search:
// in each step subtract the largest possible Fibonacci number
unsigned int pos = fibonacci.size() - 1;
while (x > 0)
{
while (fibonacci[pos] > x)
pos--;
 
x -= fibonacci[pos];
result++;
}
 
return result;
}
 
// compute sum of the length of all Zeckendorf representations from 1 to x
unsigned long long search(unsigned long long x)
{
// find largest Fibonacci number <= x
auto pos = 0;
while (fibonacci[pos + 1] <= x)
pos++;
 
// strip off that Fibonacci number
auto reduced = x - fibonacci[pos];
 
// done ?
if (reduced == 0)
return fiboSum[pos];
 
// still more 1s in the binary Zeckendorf representation left ...
return fiboSum[pos] + reduced + search(reduced);
}
 
int main()
{
unsigned long long limit = 100000000000000000ULL;
std::cin >> limit;
 
// note: it took me a while to figure out that because of F(1) = F(2) = 1
// I am not allowed to represent 3 as F(1) + F(3) (which is 3 = 1 + 2)
// even though F(1) and F(3) are not consecutive
// if I remove F(1) (or F(2)) then that ambiguity disappears and everything's fine
 
// start with Fibonacci numbers F(2) and F(3)
fibonacci = { 1, 2 };
 
// F(2) has length 1, F(3) as length 1 as well plus 1 from F(2)
fiboSum = { 1, 1+1 };
 
// find all Fibonacci number below 10^17
while (fibonacci.back() < limit)
{
auto size = fibonacci.size();
auto nextFibo = fibonacci[size - 1] + fibonacci[size - 2];
fibonacci.push_back(nextFibo);
 
// "special" sum of Fibonacci numbers
auto nextSum = fiboSum [size - 1] + fiboSum [size - 2] + fibonacci[size - 2] - 1;
fiboSum.push_back(nextSum);
}
 
// NOT including 10^17
limit--;
// display result
std::cout << search(limit) << std::endl;
 
// my old test code for the first 100 numbers
//auto sum = 0;
//for (auto i = 1; i < 100; i++)
//{
// auto current = zeckendorf(i);
// sum += current;
// std::cout << i << "=" << current << " " << sum << " / " << search(i) << std::endl;
//}
 
return 0;
}

This solution contains 18 empty lines, 29 comments and 2 preprocessor commands.

Benchmark

The correct solution to the original Project Euler problem was found in less than 0.01 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL)

See here for a comparison of all solutions.

Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL.

Changelog

July 25, 2017 submitted solution
July 25, 2017 added comments

Difficulty

35% Project Euler ranks this problem at 35% (out of 100%).

Heatmap

Please click on a problem's number to open my solution to that problem:

green   solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too
yellow solutions score less than 100% at Hackerrank (but still solve the original problem easily)
gray problems are already solved but I haven't published my solution yet
blue solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much
orange problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte
red problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too
black problems are solved but access to the solution is blocked for a few days until the next problem is published
[new] the flashing problem is the one I solved most recently

I stopped working on Project Euler problems around the time they released 617.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25
26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50
51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75
76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100
101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125
126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150
151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175
176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200
201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225
226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250
251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275
276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300
301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325
326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350
351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375
376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400
401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425
426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450
451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475
476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500
501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525
526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550
551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575
576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600
601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625
626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650
651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675
676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700
701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725
726 727 728 729 730 731 732 733 734 735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750
751 752 753 754 755 756 757 758 759 760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775
776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798 799 800
801 802 803 804 805 806
The 310 solved problems (that's level 12) had an average difficulty of 32.6% at Project Euler and
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.

My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.

Look at my progress and performance pages to get more details.

more about me can be found on my homepage, especially in my coding blog.
some names mentioned on this site may be trademarks of their respective owners.
thanks to the KaTeX team for their great typesetting library !